package com.hnj.printtestticketserialportdemo;


import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;

import com.hnj.dp_nserialportlist.Serialport_Factory;
import com.hnj.printtestticketserialportdemo.PopMenu.OnItemClickListener;
import com.szzk.percent.support.PercentRelativeLayout;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Intent;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

public class MainActivity extends Activity {

	private PercentRelativeLayout input_prl,drivername_prl;
	public PopMenu versions,drivername_pm;
	private TextView baud_rate_et,drivername_tv,printstate;
	private Button save_set_bt,testpage_bt,testprint_bt;
	private ImageView back_iv;
	private Handler mhandler;
	public static Serialport_Factory sf;
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		this.requestWindowFeature(Window.FEATURE_NO_TITLE);
		getWindow().setSoftInputMode( WindowManager.LayoutParams.SOFT_INPUT_STATE_HIDDEN);//一开始不会弹出软键盘需要点击文本框才会弹出软键盘
		setContentView(R.layout.activity_main);
		SharedPreferencesUtil.initPreferences(this);
		mhandler=new MHandler();
		sf=Serialport_Factory.getSerialport_Factory(this,mhandler);
		baud_rate_et=(TextView)findViewById(R.id.baud_rate_et);
		drivername_tv=(TextView)findViewById(R.id.drivername_tv);
		printstate=(TextView)findViewById(R.id.printstate);
		input_prl=(PercentRelativeLayout)findViewById(R.id.input_prl);
		drivername_prl=(PercentRelativeLayout)findViewById(R.id.drivername_prl);
		save_set_bt=(Button)findViewById(R.id.save_set_bt);
		testpage_bt=(Button)findViewById(R.id.testpage_bt);
		testprint_bt=(Button)findViewById(R.id.testprint_bt);
		back_iv=(ImageView)findViewById(R.id.back_iv);
		versions = new PopMenu();
		drivername_pm = new PopMenu();
		getbaud_rate();
		testpage_bt.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				if(sf.isConnection())
				{
					sf.PrintTestPage();//打印自测页
				}else {
					Toast_Util.ToastString(getApplicationContext(), "请连接打印机");
				}

			}
		});
		testprint_bt.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View v) {

					Intent intent=new Intent(MainActivity.this,NormalPrintActivity.class);
					startActivity(intent);	
				
			}
		});
		versions.setOnItemClickListener(new OnItemClickListener() {			
			@Override
			public void onItemClick(int index) {
				String str=versions.getItem(index);
				baud_rate_et.setText(str);	
			}
		});
		
		drivername_pm.setOnItemClickListener(new OnItemClickListener() {			
			@Override
			public void onItemClick(int index) {
				String str=drivername_pm.getItem(index);
				drivername_tv.setText(str);	
			}
		});
		input_prl.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View v) {				
				versions.showAsDropDown(v,getApplicationContext(),v.getWidth());				
			}
		});
		drivername_prl.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View v) {				
				drivername_pm.showAsDropDown(v,getApplicationContext(),v.getWidth());				
			}
		});
		save_set_bt.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View arg0) {
				String com_name=drivername_tv.getText().toString().trim();
				String baud_rate=baud_rate_et.getText().toString().trim();
				if(com_name.equals("")||baud_rate.length()<=0)
				{
					Toast_Util.ToastString(getApplicationContext(), R.string.please_enter_a_serial_port_name);//请输入串口名称
				}else {
					
					boolean isopen=false;
					if(!baud_rate.equals("")&&!com_name.equals(""))
					{
						isopen=sf.OpenPort(com_name, baud_rate);
					}else {
						isopen=sf.OpenPort("ttyS0", "115200");  
					}	
					if(isopen)
					{
						mhandler.sendEmptyMessageDelayed(1, 1000);
						Toast_Util.ToastString(getApplicationContext(), R.string.connected);
						SharedPreferencesUtil.savecom_name(com_name);
						SharedPreferencesUtil.savebaud_rate(baud_rate);
						sf.Check_Paper();
					}else {
						Toast_Util.ToastString(getApplicationContext(), R.string.unconnected);
					}
				}				
			}
		});
		back_iv.setOnClickListener(new OnClickListener() {			
			@Override
			public void onClick(View arg0) {
				// TODO Auto-generated method stub
				finish();
			}
		});
	}
	
	/**
	 * 从Assets中读取图片
	 */
	private Bitmap getImageFromAssetsFile(String fileName) {
		Bitmap image = null;
		AssetManager am = getResources().getAssets();
		try {
			InputStream is = am.open(fileName);
			image = BitmapFactory.decodeStream(is);
			is.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

		return image;

	}
	private void getbaud_rate()
	{
		String baudrate=SharedPreferencesUtil.getbaud_rate();
		String comname=SharedPreferencesUtil.getcom_name();
		if(baudrate!=null)
		{
			if(baudrate.length()==0){
				baud_rate_et.setText("115200");
			}else {
				baud_rate_et.setText(baudrate);
			}
		}
		if(comname!=null)
		{
			if(comname.length()==0){
				drivername_tv.setText("ttySAC0");
			}else {
				drivername_tv.setText(comname);
			}			
		}
		versions.clearItems();		
		versions.addItem("1200");
		versions.addItem("2400");
		versions.addItem("4800");
		versions.addItem("9600");
		versions.addItem("14400");
		versions.addItem("19200");
		versions.addItem("38400");
		versions.addItem("57600");
		versions.addItem("115200");
		versions.addItem("230400");
		versions.addItem("256000");
		versions.addItem("500000");
		versions.addItem("750000");
		versions.addItem("1125000");
		String dlist[]=sf.getAllDevices();//获取所有串口设备名称
		drivername_pm.clearItems();
		for(int i=0;i<dlist.length;i++)
		{
			drivername_pm.addItem(dlist[i]);
		}
	}
	int k=0;
	int j=0;
	public static boolean ispage=false;//纸张状态
	@SuppressLint("HandlerLeak")
	 class MHandler extends Handler {
				@Override
				public void handleMessage(Message msg) {
					super.handleMessage(msg);			
					switch (msg.what) {	
					case 1:{//检查缺纸状态
						MainActivity.sf.PrintText("串口打开成功",2,2,20);
						MainActivity.sf.PrintText(" ",2,1,30,1);
						MainActivity.sf.PrintText(" ",3,1,20,1);	
						
						MainActivity.sf.PrintText("",1,1,10);
						break;
					}
			
						
				 case Serialport_Factory.PAPER_STATE:{//检查缺纸状态
							j++;
							boolean p=msg.getData().getBoolean("PAPER_STATE");
							if(p)
							{
								ispage=true;
								Toast_Util.ToastString(getApplicationContext(), "打印机有纸");								
							}else {
								ispage=false;
								k++;
								Toast_Util.ToastString(getApplicationContext(), "打印机缺纸");
								
							}
							break;
						}
					case Serialport_Factory.PRINTSTATE:{//打印状态
						boolean printstate=msg.getData().getBoolean("printstate");
						if(printstate)
						{
//							Toast_Util.ToastString(getApplicationContext(), "print completed");//打印完成
						}else
						{
//							Toast_Util.ToastString(getApplicationContext(), "Print failure");//打印失败
						}
						 
						break;
					}
					}
				}
			}



}
